function [ab_names, concs, plates] = ampc_import_conc(xlsname)
% importing the fluid names data
[~,t] = xlsread(xlsname, 'Fluids');
tmp_names = t(2:find(ismember(t(:,2),''),1)-1,2);
clear t;

% importing the concs data
[n,~,r] = xlsread(xlsname, 'Tabular');
h = r(1,:);
b = r(2:end,:);
clear r;
concs_tmp = n(:,find(ismember(h, 'Concentration')) : find(ismember(h, 'DMSO %'))-2);
concs_tmp(isnan(concs_tmp)) = 0;
plate_col = find(ismember(h, 'Plate'));
plate_vec = cell2mat(b(:,plate_col));
plates = unique(plate_vec);


for i = 1:numel(plates)
    concs{i} = concs_tmp(plate_vec == plates(i), :);
end
ab_names = tmp_names;
