function IC_struct = Run_fit_IC_final(mp_all, mage)
c0 = [500 750 50 6.25 2.5];

tic;
for m_pool = 1:2
    r_no_drug = [median(cell2mat({mage(m_pool).ab(12).Residue.Mat}').*mage(m_pool).ab(12).Seq_data.Count',2)
        median(mage(m_pool).ab(12).Seq_data.WT.*mage(m_pool).ab(12).Seq_data.Count)];
    g_pos = find(r_no_drug >= 10);
    [Pos_tmp, aa_tmp] =  meshgrid(arrayfun(@(x,y) sprintf('%s%g', x,y), mage(m_pool).orig_aa, mage(m_pool).Pos-16, 'UniformOutput', 0), ...
        mage(m_pool).aa');
    
    IC_struct(m_pool).Pos = [Pos_tmp(g_pos(1:end-1)); 'WT'];
    IC_struct(m_pool).aa = [aa_tmp(g_pos(1:end-1)); ' '];
%     IC_struct(m_pool).IC_mat = zeros(numel(g_pos),10);
%     IC_struct(m_pool).Ni_mat = zeros(numel(g_pos),10);
%     IC_struct(m_pool).H_mat = zeros(2,10);
    
    for j = 1:10
        IC_struct(m_pool).ab(j).Name = mage(m_pool).ab(j).Name;
        IC_struct(m_pool).ab(j).conc = [0 c0(ceil(j/2))*1.55.^(-mage(m_pool).ab(j).Conc(1:end)-1)'];
        
        
        tmp_reads = round([repmat(r_no_drug, 1,1,2), [cell2mat({mage(m_pool).ab(j).Residue.Mat}').*permute(mage(m_pool).ab(j).Seq_data.Count,[3 1 2]); ...
            permute(mage(m_pool).ab(j).Seq_data.WT.*mage(m_pool).ab(j).Seq_data.Count, [3 1 2])]]);
        IC_struct(m_pool).ab(j).Reads = tmp_reads(g_pos,:,:);
        IC_struct(m_pool).ab(j).OD = permute([repmat(median(mage(m_pool).ab(12).Seq_data.OD), 1, 2); mage(m_pool).ab(j).Seq_data.OD], [3 1 2]);
    end
    
    IC_struct(m_pool).ab([3 4 9 10]) = [];
%     IC_struct(m_pool).ab([1 2 5 6 7 8 ]) = [];
end
%% Calculating the model fit
[IC1, Ni1, H1] = fit_IC_final(IC_struct);
%
% save([mp_all 'Results/IC_struct'], 'IC_struct');
% save ~/Dropbox/Dor_Phd/ampC/Results/IC_struct_AMP_MER IC_struct;
for m_pool = 1:2
    IC_struct(m_pool).IC_mat = IC1{m_pool};
    IC_struct(m_pool).Ni_mat = Ni1{m_pool};
    IC_struct(m_pool).H_mat = H1;
end
%
save([mp_all 'Results/IC_struct'], 'IC_struct');