function [IC1, Ni, H_mat] = fit_IC_final(IC_struct)
figure(1); clf;
Ni = [];
R_exp = [];
nab = numel(IC_struct(1).ab);
for mp1 = 1:numel(IC_struct)
    m(mp1) = size(IC_struct(mp1).ab(1).Reads,1) ; % number of mutants
    
    Ni{mp1} = IC_struct(mp1).ab(1).Reads(:,1,1)./(15*sum(IC_struct(mp1).ab(1).Reads(:,1,1)));
    
    IC0{mp1} = zeros(m(mp1), nab);
    
    
    for i = 1:nab
        R1 = IC_struct(mp1).ab(i).Reads;
        OD1 = IC_struct(mp1).ab(i).OD-0.04;
        R4IC = R1./sum(R1).*OD1;
        c_all = IC_struct(mp1).ab(i).conc(:,:,1);
        IC0{mp1}(:,i) = c_all(cellfun(@(x) find(x,1), mat2cell([mean(R4IC(:,1:end-1,:),3)<R4IC(:,1)/4 ones(size(R1,1),1)], ones(size(R4IC,1),1), size(R4IC,2) )))';
        IC0{mp1}(IC0{mp1}(:,i) == c_all(2),i) = c_all(2)/2;
    end
    c_minmax(:,:,mp1) = cell2mat(arrayfun(@(x) x.conc([2 end])', IC_struct(mp1).ab, 'UniformOutput', 0));
end
c_minmax = [min(c_minmax(1,:,:),[],3); max(c_minmax(2,:,:),[],3)];

H0 = [4 ;2];

for ab2 = 1:nab/2
    ab = ab2*2-([1 0]);
    c = 0;
    par0 = [reshape([IC0{1}(1:end-1,ab); ... sp1 parameters
        IC0{2}(1:end-1,ab); ... sp2 parameters
        min([IC0{1}(end,ab); IC0{2}(end,ab)])], [], 1); H0]; % WT IC50 and Hill coeff H
    
    ub = [reshape(ones(m(1)+m(2)-1,1).*c_minmax(2,ab)*2.4,[],1); 20 ;20];
    
    lb = [reshape(ones(m(1)+m(2)-1,1).*c_minmax(1,ab)/2.4,[],1); 1; 1];
    
    t_smp = 16 ;
    subplot(2,1,1); cla;
    semilogy(par0, '.k'); hold on;
    d = plot(par0, '.r');
    e = 1;
    [par1, resnorm,residual,exitflag,output,lambda,jacobian] = lsqnonlin(@ML_model,par0, lb, ub, ...
        optimset('MaxFunEvals', 10000000, 'MaxIter', 10000, 'UseParallel',1));..., ...     'PlotFcn', 'optimplotfval')) ;
        %     par1 = fminsearch(@ML_model,par0, ... lb, ub, ...
    %         optimset('MaxFunEvals', 10000000, 'MaxIter', 1000000, 'UseParallel',1));..., ...     'PlotFcn', 'optimplotfval')) ;
    toc
    par3 = reshape(par1(1:end-2), [],2);
    IC_wt1 = par3(end,:);
    IC1{1}(:,ab) = [par3(1:m(1)-1,:); IC_wt1];
    IC1{2}(:,ab) = [par3(m(1):m(1)+m(2)-2,:); IC_wt1];
    H_mat(:,ab) = par1(end-1:end)*[1 1];
    R_exp1(:,ab) = R_exp;
    cef = 1;
    err = 1;
end
% IC1 = reshape(par1(1:numel(IC0)), m,nab);
% Ni1 = par1(numel(IC0)+1:numel(IC0)+m) ;
% H1 = par1(numel(IC0)+m+1:numel(IC0)+m+2);

return

    function l_t = ML_model(par)
        c = c+1;
        % parse param
        par2 = reshape(par(1:end-2),[],2);
        IC{1} = par2(1:(m(1)-1),:);
        IC{2} = par2(m(1):m(1)+m(2)-2,:);
        IC_wt = par2(end,:);
        H{1} = ones(m(1),1)*par(end-1);
        H{1}(end) = par(end);
        H{2} = ones(m(2),1)*par(end-1);
        H{2}(end) = par(end);
        
        % looping on sequencing pools
        n_s = 0;
        for mp = 1:2
            n_s = n_s+numel([IC_struct(mp).ab(ab).Reads])/2;
        end
        l_t = zeros(n_s, 1);
        cr = 0;
        for dr = 1:2
            for mp = 1:2
                % looping on the drugs
                R = IC_struct(mp).ab(ab(dr)).Reads;
                
                OD = (IC_struct(mp).ab(ab(dr)).OD)/(IC_struct(mp).ab(ab(dr)).OD(1));
                OD(OD>1) = 1; OD(OD<0.002) = 0.002;
                
                % concentration vector
                Cv = IC_struct(mp).ab(ab(dr)).conc;
                
                Nf = ampc_calc_Nf(Cv,Ni{mp}, [IC{mp}(:,dr); IC_wt(dr)], H{mp}, t_smp);
                Nf_e = Nf./sum(Nf);
                
                R_e = sum(R).*Nf_e;
                
                Err = max(cat(4, sqrt(R), (abs(diff(R./sum(R),[],3)).*R), ones(size(R))), [], 4);
                
                cur_l_t = sqrt(reshape(((R_e-R)./Err).^2 + 100*(sum(Nf)-OD).^2./OD, [],1));
                l_t(cr+1:cr+numel(cur_l_t))  = cur_l_t;
                cr = cr+numel(cur_l_t);
                R_exp{mp} = Nf_e;
            end
            L = sqrt(mean(l_t));
            
            if c == 1
                subplot(2,1,2); cla;
                semilogy(l_t, '.k'); hold on;
                e = plot(l_t, '.r'); drawnow;
                drawnow;
                ylim([1e-5 1e5])
            end
        end
        d.YData = par; drawnow;
        e.YData = l_t;  drawnow;
        if ~mod(c,100)
            
            fprintf('%g - L = %.4e\n', c, L)
        end
    end
end